#include "draw.h"

//    
inline int ReturnNumberAn(char* buf)
{
	int i,k;

	k=-1;

	for(i=0;i<max_animat_surf;i++)
		if (lstrcmp(buf,max_animat[i])==0) 
		{
			k=0;
			break;
		}

	if (k==0) return i;

	return k;
}

//    text_pic
inline int ReturnNumber(char* buf)
{
	int i,k;

	k=-1;

	for(i=0;i<max_text_pic;i++)
		if (lstrcmp(buf,text_pic[i])==0) 
		{
			k=0;
			break;
		}

	if (k==0) return i;

	return 0;
}

//    text_pic_m
inline int ReturnNumber1(char* buf)
{
	int i,k;

	k=-1;

	for(i=0;i<max_text_pic_m;i++)
		if (lstrcmp(buf,text_pic_m[i])==0) 
		{
			k=0;
			break;
		}

	if (k==0) return i;

	return 0;
}

int DirectDrawC(HWND h)
{
	LPDIRECTDRAW ddraw1;
	HRESULT r;
	DirectDrawCreate(0,&ddraw1,0);
	r=ddraw1->QueryInterface(IID_IDirectDraw2,(void**)&ddraw2);
	if (r!=S_OK) return 1;
	ddraw1->Release();
	ddraw1=NULL;
	r=ddraw2->SetCooperativeLevel(h,DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN | DDSCL_ALLOWREBOOT);
	if (r!=DD_OK) return 2;
	DWORD da;
	HDC dc=GetDC(h);
	da=GetDeviceCaps(dc,BITSPIXEL);
	winD=da;
	winX=GetDeviceCaps(dc,HORZRES);
	winY=GetDeviceCaps(dc,VERTRES);
	ReleaseDC(h,dc);
	ddraw2->SetDisplayMode(width,height,da,0,0);
	if (da!=depth) r=ddraw2->SetDisplayMode(width,height,depth,0,0);
	if (r!=DD_OK) return 3;
	//   
	DDSURFACEDESC desc;
	ZeroMemory(&desc,sizeof(desc));
	desc.dwSize=sizeof(desc);
	desc.dwFlags=DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
	desc.ddsCaps.dwCaps=
		DDSCAPS_PRIMARYSURFACE | DDSCAPS_FLIP | DDSCAPS_COMPLEX;
	desc.dwBackBufferCount=1;
	r=ddraw2->CreateSurface(&desc,&primsurf,0);
	if (r!=DD_OK) return 4;
	DDSCAPS sc;
	sc.dwCaps=DDSCAPS_BACKBUFFER;
	r=primsurf->GetAttachedSurface(&sc,&backsurf);
	if (r!=DD_OK) return 5;
	int i;
	for(i=1;i<100;i++)
	font[i]=CreateFont( i, 0, 0, 0,
		FW_NORMAL, FALSE, FALSE, FALSE,
		RUSSIAN_CHARSET,
		OUT_DEFAULT_PRECIS,
		CLIP_DEFAULT_PRECIS,
		DEFAULT_QUALITY,
		VARIABLE_PITCH,
		"impact");
	for(i=1;i<100;i++)
	font1[i]=CreateFont( i, 0, 0, 0,
		FW_NORMAL, FALSE, FALSE, FALSE,
		RUSSIAN_CHARSET,
		OUT_DEFAULT_PRECIS,
		CLIP_DEFAULT_PRECIS,
		DEFAULT_QUALITY,
		VARIABLE_PITCH,
		"arial");

	for(i=0;i<MAX_SURF;i++) pv[i]=NULL;

	DDCOLORKEY ddck1;
	ddck1.dwColorSpaceLowValue=RGB(0,0,0);
	ddck1.dwColorSpaceHighValue=RGB(0,0,0);
	vert=CreateSurface_(ddraw2,120,120,16);
	vert->SetColorKey(DDCKEY_SRCBLT,&ddck1);
	//   
	for(i=0;i<MAX_MENU_SUR;i++) pv1[i]=NULL;
	char s[256];
	for(i=0;i<MAX_MENU_SUR;i++)
	{
		if (i==max_text_pic_m) break;
		lstrcpy(s,"BMP\\");
		lstrcat(s,text_pic_m[i]);
		if (pv1[i]==NULL) pv1[i]=CreateSurface1_(ddraw2,s,"pak\\pak1.pak",depth);
		if (pv1[i]==NULL) return 10000+i;
		pv1[i]->SetColorKey(DDCKEY_SRCBLT,&ddck1);
	}

	return RestoreSurface();
}

int DeleteSurf(HWND h)
{
	for(int i=0;i<MAX_SURF;i++)
		if (pv[i])
		{
			pv[i]->Release();
			pv[i]=NULL;
		}
	return 0;
}

int DirectDrawEnd(HWND h)
{
	if (ddraw2) ddraw2->SetDisplayMode(winX,winY,winD,0,0);
	for(int i=0;i<MAX_SURF;i++)
		if (pv[i])
		{
			pv[i]->Release();
			pv[i]=NULL;
		}
	for(i=0;i<MAX_MENU_SUR;i++)
		if (pv1[i])
		{
			pv1[i]->Release();
			pv1[i]=NULL;
		}
	if (vert)
	{
		vert->Release();
		vert=NULL;
	}
	if (backsurf) 
	{
		backsurf->Release();
	    backsurf=NULL;
	}
	if (primsurf) 
	{
		primsurf->Release();
	    primsurf=NULL;
	}
	if (ddraw2) 
	{
		ddraw2->Release();
	    ddraw2=NULL;
	}
	return 0;
}

int NoneDraw(HWND h)
{
	int i,j,k;
	if (primsurf->IsLost())
	{
		HRESULT r;
		r=primsurf->Restore();
		r=backsurf->Restore();
		if (vert->IsLost()) vert->Restore();
		Rest();
	}
	ClearSurface(backsurf,0,0,0);

	if (menu==0)
	if (ProgFaze==3)// 
	{
		DrawBeginLevel();
	}
	if (menu==0)
	if (ProgFaze==2)// 
	{
		//   
		DrawLevel();
		//    
		DrawBuild();
		//   
		if (trace1) DrawTrace();
		//    
		DrawObject(0);
		//  
		DrawPoav();
		//
		DrawGun();
		// 
		DrawEffects();
		//    
		DrawObject(1);
		// 
		if (health) DrawHealth();
		// 
		DrawRadarHealth();
		//   
		DrawOtherTanks();
		//  
		if (mn_1)
		if (gun) DrawMGun();
		// FPS
		//if (fps_ot) DrawFps();
		if (pause_game)
		{
			BltSurface(backsurf,pv[ReturnNumber("fon\\f2.bmp")],3,150,true);
		}
		Draw_Text();
		//  
		DrawMouseCursor();
		//
		if (consoleProcess!=0) DrawConsole();
	}

	if (menu!=0)
	{
		//   
		FonMenu();
		//    
		DrawMenu();
	}
	/*if (menu==0)
	{
	if (GameFaze==2)
	{
		DrawComment();
	}
	if (GameFaze==1)
	{
	//   
	DrawLevel();
	//    
	DrawBuild();
	//   
	if (trace1) DrawTrace();
	//    
	DrawObject(0);
	//
	DrawGun();
	// 
	DrawEffects();
	//    
	DrawObject(1);
	// 
	if (health) DrawHealth();
	//  
	if (mn_1)
	if (gun) DrawMGun();
	// FPS
	if (fps_ot) DrawFps();
	Draw_Text();
	//  
	DrawMouseCursor();
	}
	}*/
	if (menu==0)
	if (ProgFaze==1)//  
	{
		//
		BltSurface(backsurf,pv1[ReturnNumber1("fon\\f1.bmp")],8,40);
	}
	primsurf->Flip(0,DDFLIP_WAIT);
	return 0;
}

int RestoreSurface()
{
	char s[256];
	DDCOLORKEY ddck,ddck1;
	ddck.dwColorSpaceLowValue=RGB(255,255,255);
	ddck.dwColorSpaceHighValue=RGB(255,255,255);
	ddck1.dwColorSpaceLowValue=RGB(0,0,0);
	ddck1.dwColorSpaceHighValue=RGB(0,0,0);
	DrawLoading(3,0);
	for(int i=0;i<MAX_SURF;i++)
	{
		if (i==max_text_pic) break;
		lstrcpy(s,"BMP\\");
		lstrcat(s,text_pic[i]);
		if (pv[i]!=NULL) {
			pv[i]->Release();
			pv[i]=NULL;
		}
		if (pv[i]==NULL) pv[i]=CreateSurface_(ddraw2,s,"pak\\pak1.pak",depth);
		if (pv[i]==NULL) return 10000+i;
		pv[i]->SetColorKey(DDCKEY_SRCBLT,&ddck1);
		DrawLoading(4,i);
	}
	return 0;
}

int Rest()
{
	char s[256];
	int j,k;
	char buf[256];
	HDC hdc;
	lstrcpy(buf,ReturnText("RESTORE"));
	primsurf->GetDC(&hdc);
	SelectObject(hdc,font[20]);
	SetBkMode(hdc,TRANSPARENT);
	SetTextColor(hdc,RGB(255,255,255));
	TextOut(hdc,0,460,buf,lstrlen(buf));
	primsurf->ReleaseDC(hdc);
	for(int i=0;i<MAX_MENU_SUR;i++)
	{
		if (i==max_text_pic_m) break;
		if (pv1[i]->IsLost()==false) continue;
		pv1[i]->Restore();
		lstrcpy(s,"BMP\\");
		lstrcat(s,text_pic_m[i]);
		LoadSurface_(ddraw2,pv1[i],s,"pak\\pak1.pak",depth);
	}
	for(i=0;i<MAX_SURF;i++)
	{
		if (i==max_text_pic) break;
		if (pv[i]->IsLost()==false) continue;
		pv[i]->Restore();
		lstrcpy(s,"BMP\\");
		lstrcat(s,text_pic[i]);
		LoadSurface_(ddraw2,pv[i],s,"pak\\pak1.pak",depth);
	}
	//fputs("ss\n",flog);
	//wsprintf(s,"%d\n",max_type_rot);
	//fputs(s,flog);
	for(i=0;i<max_type_rot;i++)
	{
		fputs("aa",flog);
		for(k=0;k<4;k++)
		{
			if (pv[max_text_pic+i*4+k]->IsLost()) {
				pv[max_text_pic+i*4+k]->Restore();
				//wsprintf(s," %d-%k  \n",i,k);
				//fputs(s,flog);
			}
			else
			{
				//wsprintf(s,"  %d-%k  \n",i,k);
				//fputs(s,flog);
			}
		}
		for(j=0;j<36;j++)
		{
			if (i==0)
			{
			Vertix1(vert,pv[ReturnNumber(type_object[type_rot[i]].bmp[0])],
				j*100,type_object[type_rot[i]].xSize*10,type_object[type_rot[i]].ySize*10,3,type_object[type_rot[i]].xSize*10,type_object[type_rot[i]].ySize*10);
			BltSurface(pv[max_text_pic+i*4],vert,(j-0.1)*type_object[type_rot[i]].xSize*15,-type_object[type_rot[i]].xSize*15*0.1);
			Vertix1(vert,pv[ReturnNumber(type_object[type_rot[i]].bmp[1])],
				j*100,type_object[type_rot[i]].xSize*10,type_object[type_rot[i]].ySize*10,3,type_object[type_rot[i]].xSize*10,type_object[type_rot[i]].ySize*10);
			BltSurface(pv[max_text_pic+i*4+1],vert,(j-0.1)*type_object[type_rot[i]].xSize*15,-type_object[type_rot[i]].xSize*15*0.1);
			Vertix1(vert,pv[ReturnNumber(type_object[type_rot[i]].bmp1)],
				j*100,type_object[type_rot[i]].xSize*10,type_object[type_rot[i]].ySize*10,3,type_object[type_rot[i]].xSize*10,type_object[type_rot[i]].ySize*10);
			BltSurface(pv[max_text_pic+i*4+2],vert,(j-0.1)*type_object[type_rot[i]].xSize*15,-type_object[type_rot[i]].xSize*15*0.1);
			Vertix1(vert,pv[ReturnNumber(type_object[type_rot[i]].bmp2)],
				j*100,type_object[type_rot[i]].xSize*10,type_object[type_rot[i]].ySize*10,3,type_object[type_rot[i]].xSize*10,type_object[type_rot[i]].ySize*10);
			BltSurface(pv[max_text_pic+i*4+3],vert,(j-0.1)*type_object[type_rot[i]].xSize*15,-type_object[type_rot[i]].xSize*15*0.1);
			}
			else
			{
				Vertix1(vert,pv[ReturnNumber(type_object[type_rot[i]].bmp[0])],
				j*100,type_object[type_rot[i]].xSize*10,type_object[type_rot[i]].ySize*10,3,type_object[type_rot[i]].xSize*10,type_object[type_rot[i]].ySize*10);
			BltSurface(pv[max_text_pic+i*4],vert,(j-0.1)*type_object[type_rot[i]].xSize*15,-type_object[type_rot[i]].xSize*15*0.1);
			}

		}
	}
	return 0;
}

void DrawLevel()
{
	/*
	       
	 ,       .
	       .
	*/
	int i,j,k;
	for(i=-1;i<SCREEN_Y/40+1;i++)
		for(j=-1;j<SCREEN_X/40+1;j++)
			if (((i+SY/40>=0) && (j+SX/40>=0)) &&
				((i+SY/40<levy) && (j+SX/40<levx))){
				k=ReturnNumberAn(text_pic[levelbuf[(i+SY/40)*levx+j+SX/40]]);
				if (k==-1 || tim%20<10)
				BltSurface1(backsurf,pv[levelbuf[(i+SY/40)*levx+j+SX/40]],
							j*40-SX%40,i*40-SY%40,0,0,40,40);
				if (k>0 && tim%20>9)
				BltSurface1(backsurf,pv[levelbuf[(i+SY/40)*levx+j+SX/40]],
							j*40-SX%40,i*40-SY%40,40,0,80,40);
			}
}

void DrawBuild()
{
	for(int i=0;i<max_build;i++)
		if ((build[i].x*40+type_build[build[i].type].xSize*10>SX) &&
			(build[i].x*40<SX+SCREEN_X) &&
			(build[i].y*40+type_build[build[i].type].ySize*10>SY) &&
			(build[i].y*40<SY+SCREEN_Y))
			BltSurface(backsurf,pv[ReturnNumber(type_build[build[i].type].bmp)],
				build[i].x*40-SX,build[i].y*40-SY,true);
}

void DrawObject(int ght)
{
	int alf;//     
	int a,s,d;
	for(int i=0;i<max_object;i++)
		if ((ght==0 & type_object[object[i].type].h!=112))
		if (object[i].on_off)
		if (object[i].Health<=0)
		if ((object[i].x+type_object[object[i].type].xSize*10>SX) &&
			(object[i].x<SX+SCREEN_X) &&
			(object[i].y+type_object[object[i].type].ySize*10>SY) &&
			(object[i].y<SY+SCREEN_Y)){
				alf=object[i].Rotat_1;
				if (alf>0 && alf<100) alf=100;
				if (alf>800 && alf<900) alf=800;
				if (alf>900 && alf<1000) alf=1000;
				if (alf>1700 && alf<1800) alf=1700;
				if (alf>1800 && alf<1900) alf=1900;
				if (alf>2600 && alf<2700) alf=2600;
				if (alf>2700 && alf<2800) alf=2800;
				if (alf>3500 && alf<3600) alf=3500;
				a=alf/100;
				s=type_object[object[i].type].xSize*15;
				//   
				BltSurface1(backsurf,pv[max_text_pic+ReturnSurfaceTurn(0)*4+3],
					floor(object[i].x)-SX-type_object[object[i].type].xSize*10+s*0.1,floor(object[i].y)-SY-type_object[object[i].type].ySize*10+s*0.1,a*s,0,(a+1)*s,s,true);
			}
	for(i=0;i<max_object;i++)
		if ((ght==0 & type_object[object[i].type].h!=112) ||
			(ght==1 & type_object[object[i].type].h==112))
		if (object[i].on_off)
		if (object[i].Health>0)
		if ((object[i].x+type_object[object[i].type].xSize*10>SX) &&
			(object[i].x<SX+SCREEN_X) &&
			(object[i].y+type_object[object[i].type].ySize*10>SY) &&
			(object[i].y<SY+SCREEN_Y)){
				alf=object[i].Rotat_1;
				if (alf>0 && alf<100) alf=100;
				if (alf>800 && alf<900) alf=800;
				if (alf>900 && alf<1000) alf=1000;
				if (alf>1700 && alf<1800) alf=1700;
				if (alf>1800 && alf<1900) alf=1900;
				if (alf>2600 && alf<2700) alf=2600;
				if (alf>2700 && alf<2800) alf=2800;
				if (alf>3500 && alf<3600) alf=3500;
				a=alf/100;
				s=type_object[object[i].type].xSize*15;
				d=object[i].Bmp/3;
				//   
				/*BltSurface1(backsurf,pv[max_text_pic+ReturnSurfaceTurn(object[i].type)*4+d],
					floor(object[i].x)-SX-type_object[object[i].type].xSize*10+s*0.1,floor(object[i].y)-SY-type_object[object[i].type].ySize*10+s*0.1,a*s,0,(a+1)*s,s,true);
					*/
				if (i==0)
				{
					BltSurface1(backsurf,pv[max_text_pic+ReturnSurfaceTurn(object[i].type)*4+d],
						floor(object[i].x)-SX-type_object[object[i].type].xSize*10+s*0.1,floor(object[i].y)-SY-type_object[object[i].type].ySize*10+s*0.1,a*s,0,(a+1)*s,s,true);
				}
				else
				{
					BltSurface1(backsurf,pv[max_text_pic+ReturnSurfaceTurn(object[i].type)*4],
						floor(object[i].x)-SX-type_object[object[i].type].xSize*10+s*0.1,floor(object[i].y)-SY-type_object[object[i].type].ySize*10+s*0.1,a*s,0,(a+1)*s,s,true);
				}
				//  ,   
				if (type_object[object[i].type].Bb==1)
				{
					a=object[i].Rotat_2/100;
					BltSurface1(backsurf,pv[max_text_pic+ReturnSurfaceTurn(object[i].type)*4+2],
					floor(object[i].x)-SX-type_object[object[i].type].xSize*10+s*0.1,floor(object[i].y)-SY-type_object[object[i].type].ySize*10+s*0.1,a*s,0,(a+1)*s,s,true);
				}
			}
		/*char buf[256];
		HDC hdc;
		for(i=0;i<max_object;i++)
			if (object[i].on_off)
		if (object[i].Health>0)
		{
			wsprintf(buf,"%d",object[i].r[5]);
			backsurf->GetDC(&hdc);
		SelectObject(hdc,font[20]);
		SetBkMode(hdc,TRANSPARENT);
		SetTextColor(hdc,RGB(255,0,0));
		TextOut(hdc,floor(object[i].x)-SX-type_object[object[i].type].xSize*10+s*0.1,floor(object[i].y)-SY-type_object[object[i].type].ySize*10+s*0.1+40,buf,lstrlen(buf));
		backsurf->ReleaseDC(hdc);
		}*/
}

void DrawMouseCursor()
{
	char buf[256];
	if (!LeftB) lstrcpy(buf,"PRIB\\mouse1.bmp");
	else lstrcpy(buf,"PRIB\\mouse2.bmp");
	BltSurface(backsurf,pv[ReturnNumber(buf)],mousex-10,mousey-10,true);
}

void DrawTrace()
{
	char s[256];
	int i,j;
	for(i=0;i<MAX_TRACE;i++) 
		if (trace[i].time>0) 
		if ((trace[i].x+2>SX) &&
			(trace[i].x-2<SX+SCREEN_X) &&
			(trace[i].y+2>SY) &&
			(trace[i].y-2<SY+SCREEN_Y))
		{
			j=trace[i].time/5;
			switch (j)
			{
			case 5:lstrcpy(s,"EFFECT\\trace1.bmp");break;
			case 4:lstrcpy(s,"EFFECT\\trace2.bmp");break;
			case 3:lstrcpy(s,"EFFECT\\trace3.bmp");break;
			case 2:lstrcpy(s,"EFFECT\\trace4.bmp");break;
			case 1:lstrcpy(s,"EFFECT\\trace5.bmp");break;
			case 0:lstrcpy(s,"EFFECT\\trace6.bmp");break;
			}
			BltSurface(backsurf,pv[ReturnNumber(s)],
				trace[i].x-SX-2,trace[i].y-SY-2,true);
		}
}

void DrawHealth()
{
	int k=0;
	int l;
	BltSurface(backsurf,pv[ReturnNumber("EFFECT\\health1.bmp")],
		0,SCREEN_Y-20,true);
	l=100*object[ObjectHeroy].Health/type_object[object[ObjectHeroy].type].Health;
	if (l>80) k=4;
	if (l>60 && l<=80) k=3;
	if (l>40 && l<=60) k=2;
	if (l>20 && l<=40) k=1;
	if (l>0 && l<=20) k=0;
	for(int i=0;i<l;i++)
		BltSurface1(backsurf,pv[ReturnNumber("EFFECT\\health2.bmp")],
			3+i,463,k,0,k+1,10);
}

void DrawMGun()
{
	BltSurface(backsurf,pv[ReturnNumber("EFFECT\\gun1.bmp")],
		0,0,true);
	BltSurface(backsurf,pv[ReturnNumber("EFFECT\\gun2.bmp")],
		0,50,true);
	BltSurface(backsurf,pv[ReturnNumber("EFFECT\\gun3.bmp")],
		0,100,true);
	BltSurface(backsurf,pv[ReturnNumber("EFFECT\\gun0.bmp")],
		0,(gun_-1)*50,true);
	HDC hdc;
	char buf[256];
	backsurf->GetDC(&hdc);
	SelectObject(hdc,font[40]);
	SetBkMode(hdc,TRANSPARENT);
	wsprintf(buf,"%d",object[ObjectHeroy].gun1);
	SetTextColor(hdc,RGB(100,100,0));
	TextOut(hdc,42,2,buf,strlen(buf));
	SetTextColor(hdc,RGB(255,255,0));
	TextOut(hdc,40,0,buf,strlen(buf));
	SetTextColor(hdc,RGB(200,200,0));
	TextOut(hdc,41,1,buf,strlen(buf));
	wsprintf(buf,"%d",object[ObjectHeroy].gun2);
	SetTextColor(hdc,RGB(100,100,0));
	TextOut(hdc,42,52,buf,strlen(buf));
	SetTextColor(hdc,RGB(255,255,0));
	TextOut(hdc,40,50,buf,strlen(buf));
	SetTextColor(hdc,RGB(200,200,0));
	TextOut(hdc,41,51,buf,strlen(buf));
	wsprintf(buf,"%d",object[ObjectHeroy].gun3);
	SetTextColor(hdc,RGB(100,100,0));
	TextOut(hdc,42,102,buf,strlen(buf));
	SetTextColor(hdc,RGB(255,255,0));
	TextOut(hdc,40,100,buf,strlen(buf));
	SetTextColor(hdc,RGB(200,200,0));
	TextOut(hdc,41,101,buf,strlen(buf));
	backsurf->ReleaseDC(hdc);
}

void DrawEffects()
{
	int i,k,j,ax,ay;
	for(i=0;i<MAX_EFFECT;i++) 
	{
		// 
		if (effect[i].type==1)
		if ((effect[i].x+40>SX) &&
			(effect[i].x<SX+SCREEN_X) &&
			(effect[i].y+40>SY) &&
			(effect[i].y<SY+SCREEN_Y))
		{
			k=effect[i].r[0]/5;
			if (k==3) k=2;
			BltSurface1(backsurf,pv[ReturnNumber("SMOKE\\smoke1.bmp")],
				effect[i].x-SX,effect[i].y-SY,(2-k)*40,0,(3-k)*40,40,true);
		}
		// 
		if (effect[i].type==2)
		if ((effect[i].x+10>SX) &&
			(effect[i].x-10<SX+SCREEN_X) &&
			(effect[i].y+10>SY) &&
			(effect[i].y-10<SY+SCREEN_Y))
		{
			Vertix(vert,pv[ReturnNumber("EXPLOSION\\exp6.bmp")],
				effect[i].r[0],10,10,3);
			BltSurface(backsurf,vert,effect[i].x-SX-10,effect[i].y-SY-10,true);
		}
		// 
		if (effect[i].type==3 && (effect[i].r[0]<3 || effect[i].r[0]>3))
		if ((effect[i].x+32>SX) &&
			(effect[i].x-32<SX+SCREEN_X) &&
			(effect[i].y+32>SY) &&
			(effect[i].y-32<SY+SCREEN_Y))
		{
			k=effect[i].r[1]/4;
			if (k<4)
			{
			if (effect[i].r[0]==0)
			BltSurface1(backsurf,pv[ReturnNumber("EXPLOSION\\exp1.bmp")],
				effect[i].x-SX-32,effect[i].y-SY-32,(3-k)*64,0,(4-k)*64,64,true);
			if (effect[i].r[0]==1)
			BltSurface1(backsurf,pv[ReturnNumber("EXPLOSION\\exp3.bmp")],
				effect[i].x-SX-32,effect[i].y-SY-32,(3-k)*64,0,(4-k)*64,64,true);
			if (effect[i].r[0]==2)
			BltSurface1(backsurf,pv[ReturnNumber("EXPLOSION\\exp2.bmp")],
				effect[i].x-SX-32,effect[i].y-SY-32,(3-k)*64,0,(4-k)*64,64,true);
			if (effect[i].r[0]==4)
			BltSurface1(backsurf,pv[ReturnNumber("EXPLOSION\\exp4.bmp")],
				effect[i].x-SX-32,effect[i].y-SY-32,(3-k)*64,0,(4-k)*64,64,true);
			if (effect[i].r[0]==10)
			BltSurface1(backsurf,pv[ReturnNumber("EXPLOSION\\exp7.bmp")],
				effect[i].x-SX-32,effect[i].y-SY-32,(3-k)*64,0,(4-k)*64,64,true);
			}
		}
		if (effect[i].type==3 && effect[i].r[0]==3)
		if ((effect[i].x+16>SX) &&
			(effect[i].x-16<SX+640) &&
			(effect[i].y+16>SY) &&
			(effect[i].y-16<SY+480))
		{
			k=effect[i].r[1]/4;
			if (k==4) k=3;
			BltSurface1(backsurf,pv[ReturnNumber("EXPLOSION\\exp5.bmp")],
				effect[i].x-SX-16,effect[i].y-SY-16,(3-k)*32,0,(4-k)*32,32,true);
		}
		// 
		if (effect[i].type==4)
		if ((effect[i].x+60>SX) &&
			(effect[i].x-60<SX+SCREEN_X) &&
			(effect[i].y+60>SY) &&
			(effect[i].y-60<SY+SCREEN_Y))
		{
			k=effect[i].r[0]/2;
			if (k==5) k=4;
			int alfa;//
			int r;// 
			for(j=0;j<60;j++)
			{
				//  
				alfa=j*6;
				switch(j%5)
				{
				case 0:r=10+(20-k*2);break;
				case 1:r=15+(20-k*2)*2;break;
				case 2:r=7+(20-k*2)*2;break;
				case 3:r=13+(20-k*2)*2;break;
				case 4:r=5+(20-k*2)*2;break;
				}
				if (alfa>=0 && alfa<90)
				{
					ax=-r*sin(alfa*pi/180);
					ay=-r*cos(alfa*pi/180);
				}
				if (alfa>=90 && alfa<180)
				{
					ax=-r*cos((alfa-90)*pi/180);
					ay=r*sin((alfa-90)*pi/180);
				}
				if (alfa>=180 && alfa<270)
				{
					ax=r*sin((alfa-180)*pi/180);
					ay=r*cos((alfa-180)*pi/180);
				}
				if (alfa>=270 && alfa<360)
				{
					ax=r*cos((alfa-270)*pi/180);
					ay=-r*sin((alfa-270)*pi/180);
				}
				//  
				BltSurface1(backsurf,pv[ReturnNumber("EFFECT\\tree_b.bmp")],
					effect[i].x-SX-2+ax,effect[i].y-SY-2+ay,(4-k)*4,0,(5-k)*4,4,true);
			}
		}
	}
}

void DrawGun()
{
	int i;
	for(i=0;i<MAX_GUN;i++) 
		if (gunA[i].ok==1)
		if ((gunA[i].x+2>SX) &&
			(gunA[i].x-2<SX+SCREEN_X) &&
			(gunA[i].y+2>SY) &&
			(gunA[i].y-2<SY+SCREEN_Y))
			BltSurface(backsurf,pv[ReturnNumber(type_gun[gunA[i].type].bmp[gunA[i].r[3]])],
				gunA[i].x-SX-2,gunA[i].y-SY-2,true);
}

void DrawFps()
{
	HDC hdc;
	char buf[256];
	backsurf->GetDC(&hdc);
	SelectObject(hdc,font[20]);
	SetBkMode(hdc,TRANSPARENT);
	wsprintf(buf,"fps %d",fps);
	SetTextColor(hdc,RGB(200,200,200));
	TextOut(hdc,SCREEN_X-80,0,buf,strlen(buf));
	backsurf->ReleaseDC(hdc);
}

void Draw_Text()
{
	SIZE s;
	HDC hdc;
	char buf[256],buf1[256];
	int i,j;
	//   
	//if (ProgFaze1>0 || (tyr_end==1))
	//for(j=0;j<8;j++)
	//for(i=0;i<180;i++)
	//BltSurface(backsurf,pv[ReturnNumber("EFFECT\\stat.bmp")],140+i*2,120+j*30,true);

	backsurf->GetDC(&hdc);
	//
	if (mn_3){
	SelectObject(hdc,font[20]);
	SetBkMode(hdc,TRANSPARENT);
	wsprintf(buf,"%d",Ochki);
	GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
	SetTextColor(hdc,RGB(255,255,255));
	TextOut(hdc,(SCREEN_X-s.cx)/2,0,buf,strlen(buf));
	}
	if (ProgFaze1>0)
	{
	SelectObject(hdc,font[40]);
	SetBkMode(hdc,TRANSPARENT);
	lstrcpy(buf,ReturnText("LEVELOK"));
	GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
	SetTextColor(hdc,RGB(255,0,0));
	TextOut(hdc,(SCREEN_X-s.cx)/2-1,39,buf,strlen(buf));
	SetTextColor(hdc,RGB(100,0,0));
	TextOut(hdc,(SCREEN_X-s.cx)/2+1,41,buf,strlen(buf));
	SetTextColor(hdc,RGB(200,0,0));
	TextOut(hdc,(SCREEN_X-s.cx)/2,40,buf,strlen(buf));
	SelectObject(hdc,font[20]);
	SetBkMode(hdc,TRANSPARENT);
	lstrcpy(buf,ReturnText("SPACE"));
	GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
	SetTextColor(hdc,RGB(255,255,255));
	TextOut(hdc,(SCREEN_X-s.cx)/2-1,SCREEN_Y-40,buf,strlen(buf));
	SetTextColor(hdc,RGB(100,100,100));
	TextOut(hdc,(SCREEN_X-s.cx)/2+1,SCREEN_Y-40,buf,strlen(buf));
	SetTextColor(hdc,RGB(200,200,200));
	TextOut(hdc,(SCREEN_X-s.cx)/2,SCREEN_Y-40,buf,strlen(buf));
	}
	if (ProgFaze1>0 || (tyr_end==1)){
	//
	SelectObject(hdc,font[20]);
	SetBkMode(hdc,TRANSPARENT);
	lstrcpy(buf,ReturnText("STATIST"));
	GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
	SetTextColor(hdc,RGB(0,0,200));
	TextOut(hdc,(SCREEN_X-s.cx)/2,120,buf,strlen(buf));
	lstrcpy(buf,ReturnText("STATIST1"));wsprintf(buf1,"           %i",statist[0]);
	SetTextColor(hdc,RGB(0,0,200));
	TextOut(hdc,160,150,buf,strlen(buf));
	GetTextExtentPoint32(hdc,buf1,lstrlen(buf1),&s); TextOut(hdc,480-s.cx,150,buf1,strlen(buf1));
	lstrcpy(buf,ReturnText("STATIST2"));wsprintf(buf1,"           %i",statist[1]);
	SetTextColor(hdc,RGB(0,0,200));
	TextOut(hdc,160,180,buf,strlen(buf));
	GetTextExtentPoint32(hdc,buf1,lstrlen(buf1),&s); TextOut(hdc,480-s.cx,180,buf1,strlen(buf1));
	lstrcpy(buf,ReturnText("STATIST3"));wsprintf(buf1,"           %i",statist[2]);
	SetTextColor(hdc,RGB(0,0,200));
	TextOut(hdc,160,210,buf,strlen(buf));
	GetTextExtentPoint32(hdc,buf1,lstrlen(buf1),&s); TextOut(hdc,480-s.cx,210,buf1,strlen(buf1));
	lstrcpy(buf,ReturnText("STATIST4"));
	GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
	SetTextColor(hdc,RGB(0,0,200));
	TextOut(hdc,(SCREEN_X-s.cx)/2,240,buf,strlen(buf));
	lstrcpy(buf,ReturnText("STATIST1"));wsprintf(buf1,"           %i",statist[3]);
	SetTextColor(hdc,RGB(0,0,200));
	TextOut(hdc,160,270,buf,strlen(buf));
	GetTextExtentPoint32(hdc,buf1,lstrlen(buf1),&s); TextOut(hdc,480-s.cx,270,buf1,strlen(buf1));
	lstrcpy(buf,ReturnText("STATIST2"));wsprintf(buf1,"           %i",statist[4]);
	SetTextColor(hdc,RGB(0,0,200));
	TextOut(hdc,160,300,buf,strlen(buf));
	GetTextExtentPoint32(hdc,buf1,lstrlen(buf1),&s); TextOut(hdc,480-s.cx,300,buf1,strlen(buf1));
	lstrcpy(buf,ReturnText("STATIST3"));wsprintf(buf1,"           %i",statist[5]);
	SetTextColor(hdc,RGB(0,0,200));
	TextOut(hdc,160,330,buf,strlen(buf));
	GetTextExtentPoint32(hdc,buf1,lstrlen(buf1),&s); TextOut(hdc,480-s.cx,330,buf1,strlen(buf1));
	}
	if (pause_game)
	{
	SelectObject(hdc,font[40]);
	SetBkMode(hdc,TRANSPARENT);
	lstrcpy(buf,ReturnText("PAUSE"));
	GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
	SetTextColor(hdc,RGB(255,0,0));
	TextOut(hdc,(SCREEN_X-s.cx)/2-1,(SCREEN_Y-s.cy)/2-1,buf,strlen(buf));
	SetTextColor(hdc,RGB(100,0,0));
	TextOut(hdc,(SCREEN_X-s.cx)/2+1,(SCREEN_Y-s.cy)/2+1,buf,strlen(buf));
	SetTextColor(hdc,RGB(200,0,0));
	TextOut(hdc,(SCREEN_X-s.cx)/2,(SCREEN_Y-s.cy)/2,buf,strlen(buf));
	}
	if (tyr_end==1)
	{
	SelectObject(hdc,font[40]);
	SetBkMode(hdc,TRANSPARENT);
	lstrcpy(buf,ReturnText("GAMEOVER"));
	GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
	SetTextColor(hdc,RGB(255,255,255));
	TextOut(hdc,(SCREEN_X-s.cx)/2-1,40-1,buf,strlen(buf));
	SetTextColor(hdc,RGB(100,100,100));
	TextOut(hdc,(SCREEN_X-s.cx)/2+1,40+1,buf,strlen(buf));
	SetTextColor(hdc,RGB(200,200,200));
	TextOut(hdc,(SCREEN_X-s.cx)/2,40,buf,strlen(buf));
	SelectObject(hdc,font[20]);
	SetBkMode(hdc,TRANSPARENT);
	lstrcpy(buf,ReturnText("PRESSESCAPE"));
	GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
	SetTextColor(hdc,RGB(255,255,255));
	TextOut(hdc,(SCREEN_X-s.cx)/2-1,SCREEN_Y-40,buf,strlen(buf));
	SetTextColor(hdc,RGB(100,100,100));
	TextOut(hdc,(SCREEN_X-s.cx)/2+1,SCREEN_Y-40,buf,strlen(buf));
	SetTextColor(hdc,RGB(200,200,200));
	TextOut(hdc,(SCREEN_X-s.cx)/2,SCREEN_Y-40,buf,strlen(buf));
	}
	//   
	if (mn_2)
	if (MessageOnGame>0)
	{
	SelectObject(hdc,font1[20]);
	SetBkMode(hdc,TRANSPARENT);
	lstrcpy(buf,ReturnText(MesBuf));
	GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
	SetTextColor(hdc,RGB(255,0,0));
	TextOut(hdc,(SCREEN_X-s.cx)/2-1,459,buf,strlen(buf));
	SetTextColor(hdc,RGB(100,0,0));
	TextOut(hdc,(SCREEN_X-s.cx)/2+1,461,buf,strlen(buf));
	SetTextColor(hdc,RGB(180,0,0));
	TextOut(hdc,(SCREEN_X-s.cx)/2,460,buf,strlen(buf));
	}
	if (Purpose>0)
	{
	SelectObject(hdc,font[40]);
	SetBkMode(hdc,TRANSPARENT);
	lstrcpy(buf,ReturnText("PURPOSE"));
	GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
	SetTextColor(hdc,RGB(128,255,128));
	TextOut(hdc,(SCREEN_X-s.cx)/2-1,40+(SCREEN_Y-s.cy)/2-1,buf,strlen(buf));
	SetTextColor(hdc,RGB(50,100,50));
	TextOut(hdc,(SCREEN_X-s.cx)/2+1,40+(SCREEN_Y-s.cy)/2+1,buf,strlen(buf));
	SetTextColor(hdc,RGB(100,200,100));
	TextOut(hdc,(SCREEN_X-s.cx)/2,40+(SCREEN_Y-s.cy)/2,buf,strlen(buf));
	}
	backsurf->ReleaseDC(hdc);
}

char *ReturnText(char *buf)
{
	int i;
	char b[256];
	b[0]=0;
	for(i=0;i<MAX_TEXT;i++)
		if (lstrcmp(text[i],buf)==0)
		{
			lstrcpy(b,text_txt[i]);
			break;
		}
	return b;
}

//  
int LoadInRotat()
{
	int i,j,k;
	DDCOLORKEY ddck,ddck1;
	ddck.dwColorSpaceLowValue=RGB(255,255,255);
	ddck.dwColorSpaceHighValue=RGB(255,255,255);
	ddck1.dwColorSpaceLowValue=RGB(0,0,0);
	ddck1.dwColorSpaceHighValue=RGB(0,0,0);
	DrawLoading(5,0);
	for(i=0;i<max_type_rot;i++)
	{
		for(k=0;k<4;k++)
		{
		pv[max_text_pic+i*4+k]=CreateSurface_(ddraw2,type_object[type_rot[i]].xSize*15*36,
			type_object[type_rot[i]].xSize*15,depth);
		ClearSurface(pv[max_text_pic+i*4+k],0,0,0);
		pv[max_text_pic+i*4+k]->SetColorKey(DDCKEY_SRCBLT,&ddck1);
		}
		for(j=0;j<36;j++)
		{
			/*
			Vertix1(vert,pv[ReturnNumber(type_object[type_rot[i]].bmp[0])],
				j*100,type_object[type_rot[i]].xSize*10,type_object[type_rot[i]].ySize*10,3,type_object[type_rot[i]].xSize*10,type_object[type_rot[i]].ySize*10);
			BltSurface(pv[max_text_pic+i*4],vert,(j-0.1)*type_object[type_rot[i]].xSize*15,-type_object[type_rot[i]].xSize*15*0.1,true);
			Vertix1(vert,pv[ReturnNumber(type_object[type_rot[i]].bmp[1])],
				j*100,type_object[type_rot[i]].xSize*10,type_object[type_rot[i]].ySize*10,3,type_object[type_rot[i]].xSize*10,type_object[type_rot[i]].ySize*10);
			BltSurface(pv[max_text_pic+i*4+1],vert,(j-0.1)*type_object[type_rot[i]].xSize*15,-type_object[type_rot[i]].xSize*15*0.1,true);
			Vertix1(vert,pv[ReturnNumber(type_object[type_rot[i]].bmp1)],
				j*100,type_object[type_rot[i]].xSize*10,type_object[type_rot[i]].ySize*10,3,type_object[type_rot[i]].xSize*10,type_object[type_rot[i]].ySize*10);
			BltSurface(pv[max_text_pic+i*4+2],vert,(j-0.1)*type_object[type_rot[i]].xSize*15,-type_object[type_rot[i]].xSize*15*0.1,true);
			Vertix1(vert,pv[ReturnNumber(type_object[type_rot[i]].bmp2)],
				j*100,type_object[type_rot[i]].xSize*10,type_object[type_rot[i]].ySize*10,3,type_object[type_rot[i]].xSize*10,type_object[type_rot[i]].ySize*10);
			BltSurface(pv[max_text_pic+i*4+3],vert,(j-0.1)*type_object[type_rot[i]].xSize*15,-type_object[type_rot[i]].xSize*15*0.1,true);*/
			//  
			if (i==0)
			{
				Vertix1(vert,pv[ReturnNumber(type_object[type_rot[i]].bmp[0])],
					j*100,type_object[type_rot[i]].xSize*10,type_object[type_rot[i]].ySize*10,3,type_object[type_rot[i]].xSize*10,type_object[type_rot[i]].ySize*10);
				BltSurface(pv[max_text_pic+i*4],vert,(j-0.1)*type_object[type_rot[i]].xSize*15,-type_object[type_rot[i]].xSize*15*0.1,true);
				Vertix1(vert,pv[ReturnNumber(type_object[type_rot[i]].bmp[1])],
					j*100,type_object[type_rot[i]].xSize*10,type_object[type_rot[i]].ySize*10,3,type_object[type_rot[i]].xSize*10,type_object[type_rot[i]].ySize*10);
				BltSurface(pv[max_text_pic+i*4+1],vert,(j-0.1)*type_object[type_rot[i]].xSize*15,-type_object[type_rot[i]].xSize*15*0.1,true);
				Vertix1(vert,pv[ReturnNumber(type_object[type_rot[i]].bmp1)],
					j*100,type_object[type_rot[i]].xSize*10,type_object[type_rot[i]].ySize*10,3,type_object[type_rot[i]].xSize*10,type_object[type_rot[i]].ySize*10);
				BltSurface(pv[max_text_pic+i*4+2],vert,(j-0.1)*type_object[type_rot[i]].xSize*15,-type_object[type_rot[i]].xSize*15*0.1,true);
				Vertix1(vert,pv[ReturnNumber(type_object[type_rot[i]].bmp2)],
					j*100,type_object[type_rot[i]].xSize*10,type_object[type_rot[i]].ySize*10,3,type_object[type_rot[i]].xSize*10,type_object[type_rot[i]].ySize*10);
				BltSurface(pv[max_text_pic+i*4+3],vert,(j-0.1)*type_object[type_rot[i]].xSize*15,-type_object[type_rot[i]].xSize*15*0.1,true);
			}
			else
			{
				Vertix1(vert,pv[ReturnNumber(type_object[type_rot[i]].bmp[0])],
					j*100,type_object[type_rot[i]].xSize*10,type_object[type_rot[i]].ySize*10,3,type_object[type_rot[i]].xSize*10,type_object[type_rot[i]].ySize*10);
				BltSurface(pv[max_text_pic+i*4],vert,(j-0.1)*type_object[type_rot[i]].xSize*15,-type_object[type_rot[i]].xSize*15*0.1,true);
			}
			DrawLoading(6,i*36+j);
		}
	}
	return 0;
}

int ReturnSurfaceTurn(int type)
{
	int g=0;
	int k=0;
	for(int i=0;i<max_type_rot;i++)
		if (type_rot[i]==type)
		{
			k=1;
			break;
		}
	if (k==1) g=i;
	return g;
}

void DrawLoad(int faze)
{
	switch (faze)
	{
	case 0:
		ClearSurface(primsurf,0,0,0);
		SIZE s;
		HDC hdc;
		char buf[256];
		primsurf->GetDC(&hdc);
		SelectObject(hdc,font[20]);
		SetBkMode(hdc,TRANSPARENT);
		lstrcpy(buf,ReturnText("LOAD"));
		GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
		SetTextColor(hdc,RGB(0,255,0));
		TextOut(hdc,(SCREEN_X-s.cx)/2-1,(SCREEN_Y-s.cy)/2-1-20,buf,strlen(buf));
		SetTextColor(hdc,RGB(0,100,0));
		TextOut(hdc,(SCREEN_X-s.cx)/2+1,(SCREEN_Y-s.cy)/2+1-20,buf,strlen(buf));
		SetTextColor(hdc,RGB(0,180,0));
		TextOut(hdc,(SCREEN_X-s.cx)/2,(SCREEN_Y-s.cy)/2-20,buf,strlen(buf));
		primsurf->ReleaseDC(hdc);
		break;
	}
	BltSurface(primsurf,pv1[ReturnNumber1("INTERF\\load.bmp")],170+50*faze,270);
}

void DrawComment()
{
	int i;
	for(i=0;i<16;i++) {
		BltSurface(backsurf,pv1[ReturnNumber1("INTERF\\lev_a.bmp")],i*40,0);
		BltSurface(backsurf,pv1[ReturnNumber1("INTERF\\lev_a.bmp")],i*40,218);
		BltSurface(backsurf,pv1[ReturnNumber1("INTERF\\lev_a.bmp")],i*40,230);
		BltSurface(backsurf,pv1[ReturnNumber1("INTERF\\lev_a.bmp")],i*40,458);
	}
	for(i=0;i<5;i++)
	{
		BltSurface(backsurf,pv1[ReturnNumber1("INTERF\\lev_b.bmp")],0,i*40+10);
		BltSurface(backsurf,pv1[ReturnNumber1("INTERF\\lev_b.bmp")],638,i*40+10);
	}
	for(i=0;i<7;i++)
	{
		BltSurface(backsurf,pv1[ReturnNumber1("INTERF\\lev_b.bmp")],0,i*30+240);
		BltSurface(backsurf,pv1[ReturnNumber1("INTERF\\lev_b.bmp")],638,i*30+240);
	}
	BltSurface(backsurf,pv1[ReturnNumber1("INTERF\\lev_c.bmp")],0,0);
	BltSurface(backsurf,pv1[ReturnNumber1("INTERF\\lev_c.bmp")],0,230);
	BltSurface(backsurf,pv1[ReturnNumber1("INTERF\\lev_d.bmp")],0,210);
	BltSurface(backsurf,pv1[ReturnNumber1("INTERF\\lev_d.bmp")],0,450);
	BltSurface(backsurf,pv1[ReturnNumber1("INTERF\\lev_e.bmp")],630,210);
	BltSurface(backsurf,pv1[ReturnNumber1("INTERF\\lev_e.bmp")],630,450);
	BltSurface(backsurf,pv1[ReturnNumber1("INTERF\\lev_f.bmp")],630,0);
	BltSurface(backsurf,pv1[ReturnNumber1("INTERF\\lev_f.bmp")],630,230);
	//  
	char buf[1000],buf1[1000];
	wsprintf(buf,"LEV\\lev%i.bmp",level);
	BltSurface(backsurf,pv[ReturnNumber(buf)],10,10);
	// 
	SIZE s;
	int k;
	int j=0;
	int b;
	HDC hdc;
	backsurf->GetDC(&hdc);
	SelectObject(hdc,font[20]);
	SetBkMode(hdc,TRANSPARENT);
	lstrcpy(buf,zd);
	do{
	k=0;
	for(i=0;i<lstrlen(buf);i++)
	{
		GetTextExtentPoint32(hdc,buf,i,&s);
		if (s.cx>350)
		{
			k=1;
			break;
		}
	}
	lstrcpy(buf1,buf);
	if (k==1) buf1[i]=0;
	SetTextColor(hdc,RGB(255,0,0));
	TextOut(hdc,250,20+j*20,buf1,strlen(buf1));
	if (k==0) break;
	for(b=i;b<lstrlen(buf);b++) buf[b-i]=buf[b];
	buf[b-i]=0;
	j++;
	}while (true);
	lstrcpy(buf,zd1);
	j=0;
	do{
	k=0;
	for(i=0;i<lstrlen(buf);i++)
	{
		GetTextExtentPoint32(hdc,buf,i,&s);
		if (s.cx>600)
		{
			k=1;
			break;
		}
	}
	lstrcpy(buf1,buf);
	if (k==1) buf1[i]=0;
	SetTextColor(hdc,RGB(255,0,0));
	TextOut(hdc,20,240+j*20,buf1,strlen(buf1));
	if (k==0) break;
	for(b=i;b<lstrlen(buf);b++) buf[b-i]=buf[b];
	buf[b-i]=0;
	j++;
	}while (true);
	// 
	SetTextColor(hdc,RGB(0,128,255));
	lstrcpy(buf,ReturnText("PRESSSPACE"));
	GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
	TextOut(hdc,(SCREEN_X-s.cx)/2-1,460,buf,strlen(buf));
	backsurf->ReleaseDC(hdc);
}

void FlipGdi(HWND h)
{
	HRESULT r=0;
		ddClipper->SetHWnd(0, h);
	r=ddraw2->FlipToGDISurface();
}

void FonMenu()
{
	int i,j;
	SIZE s;
	BltSurface(backsurf,pv1[ReturnNumber1("fon\\f1.bmp")],8,40);
	for(i=0;i<12;i++)
		for(j=0;j<16;j++)
			BltSurface(backsurf,pv[ReturnNumber("EFFECT\\ten.bmp")],j*40,i*40,true);
	char buf[47];
	HDC hdc;
	for(i=0;i<47;i++) buf[i]=name1[i]-180-i*3;
	backsurf->GetDC(&hdc);
	SelectObject(hdc,font1[12]);
	SetBkMode(hdc,TRANSPARENT);
	SetTextColor(hdc,RGB(66,200,200));
	TextOut(hdc,0,468,buf,46);
	SelectObject(hdc,font[60]);
	SetBkMode(hdc,TRANSPARENT);
	SetTextColor(hdc,RGB(200,0,0));
	for(i=0;i<8;i++) buf[i]=name2[i]-152-i*5;
	GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
	TextOut(hdc,(640-s.cx)/2,0," 3",7);
	SelectObject(hdc,font[30]);
	SetTextColor(hdc,RGB(0,200,0));
	for(i=0;i<20;i++) buf[i]=name3[i]-1572;
	GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
	TextOut(hdc,(640-s.cx)/2,55,buf,19);
	backsurf->ReleaseDC(hdc);
}

void DrawMenu()
{
	HDC hdc;
	char buf[256],buf1[256];
	int i,j,k;
	SIZE s;
	int a1,a2;
	
	backsurf->GetDC(&hdc);
	SelectObject(hdc,font[40]);
	SetBkMode(hdc,TRANSPARENT);

	menu3[0]=0;
	if (menu==1)
	{
		lstrcpy(buf,ReturnText("MENU1"));
		GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
		if (mousex>(640-s.cx)/2 && mousex<(640+s.cx)/2 &&
			mousey>100 && mousey<140) {
			menu3[0]=1;
			if (Left_B1 && menu3[1]==1)
			{
				if (sound)
				if (sound_blaster)
					DSOUND(ReturnNumberS("button.wav"));
					NewGame();
					return;
			}
			if (Left_B1) {
				menu3[1]=1;
				if (sound)
				if (sound_blaster)
				DSOUND(ReturnNumberS("menu.wav"));
			}
		}
		if (menu3[0]!=1 && menu3[1]!=1) SetTextColor(hdc,RGB(200,0,0));
		if (menu3[0]==1 && menu3[1]!=1) SetTextColor(hdc,RGB(200,200,0));
		if (menu3[0]!=1 && menu3[1]==1) SetTextColor(hdc,RGB(0,0,200));
		if (menu3[0]==1 && menu3[1]==1) SetTextColor(hdc,RGB(200,200,200));
		TextOut(hdc,(640-s.cx)/2,100,buf,lstrlen(buf));
		lstrcpy(buf,ReturnText("MENU2"));
		GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
		if (mousex>(640-s.cx)/2 && mousex<(640+s.cx)/2 &&
			mousey>150 && mousey<190) {
			menu3[0]=2;
			if (Left_B1 && menu3[1]==2)
			{
				if (sound)
				if (sound_blaster)
					DSOUND(ReturnNumberS("button.wav"));
				menu1=menu;
				menu=6;
				menu3[1]=1;Left_B1=false;
					return;
			}
			if (Left_B1) {
				menu3[1]=2;
				if (sound)
		if (sound_blaster)
				DSOUND(ReturnNumberS("menu.wav"));
			}
		}
		if (menu3[0]!=2 && menu3[1]!=2) SetTextColor(hdc,RGB(200,0,0));
		if (menu3[0]==2 && menu3[1]!=2) SetTextColor(hdc,RGB(200,200,0));
		if (menu3[0]!=2 && menu3[1]==2) SetTextColor(hdc,RGB(0,0,200));
		if (menu3[0]==2 && menu3[1]==2) SetTextColor(hdc,RGB(200,200,200));
		TextOut(hdc,(640-s.cx)/2,150,buf,lstrlen(buf));
		lstrcpy(buf,ReturnText("MENU3"));
		GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
		if (mousex>(640-s.cx)/2 && mousex<(640+s.cx)/2 &&
			mousey>200 && mousey<240) {
			menu3[0]=3;
			if (Left_B1 && menu3[1]==3)
			{
				if (sound)
				if (sound_blaster)
					DSOUND(ReturnNumberS("button.wav"));
				menu1=menu;
				menu=4;
				menu3[1]=1;Left_B1=false;
					return;
			}
			if (Left_B1) {
				menu3[1]=3;
				if (sound)
		if (sound_blaster)
				DSOUND(ReturnNumberS("menu.wav"));
			}
		}
		if (menu3[0]!=3 && menu3[1]!=3) SetTextColor(hdc,RGB(200,0,0));
		if (menu3[0]==3 && menu3[1]!=3) SetTextColor(hdc,RGB(200,200,0));
		if (menu3[0]!=3 && menu3[1]==3) SetTextColor(hdc,RGB(0,0,200));
		if (menu3[0]==3 && menu3[1]==3) SetTextColor(hdc,RGB(200,200,200));
		TextOut(hdc,(640-s.cx)/2,200,buf,lstrlen(buf));
		lstrcpy(buf,ReturnText("MENU4"));
		GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
		if (mousex>(640-s.cx)/2 && mousex<(640+s.cx)/2 &&
			mousey>250 && mousey<290) {
			menu3[0]=4;
			if (Left_B1 && menu3[1]==4)
			{
				if (sound)
				if (sound_blaster)
					DSOUND(ReturnNumberS("button.wav"));
				menu1=menu;
				menu=3;
				menu3[1]=1;
					return;
			}
			if (Left_B1){
				menu3[1]=4;
				if (sound)
		if (sound_blaster)
				DSOUND(ReturnNumberS("menu.wav"));
			}
		}
		if (menu3[0]!=4 && menu3[1]!=4) SetTextColor(hdc,RGB(200,0,0));
		if (menu3[0]==4 && menu3[1]!=4) SetTextColor(hdc,RGB(200,200,0));
		if (menu3[0]!=4 && menu3[1]==4) SetTextColor(hdc,RGB(0,0,200));
		if (menu3[0]==4 && menu3[1]==4) SetTextColor(hdc,RGB(200,200,200));
		TextOut(hdc,(640-s.cx)/2,250,buf,lstrlen(buf));
		lstrcpy(buf,ReturnText("MENU5"));
		GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
		if (mousex>(640-s.cx)/2 && mousex<(640+s.cx)/2 &&
			mousey>300 && mousey<340) {
			menu3[0]=5;
			if (Left_B1 && menu3[1]==5)
			{
				if (sound)
		if (sound_blaster)
					DSOUND(ReturnNumberS("button.wav"));
					Exit_Game=true;
					return;
			}
			if (Left_B1) {
				menu3[1]=5;
				if (sound)
		if (sound_blaster)
				DSOUND(ReturnNumberS("menu.wav"));
			}
		}
		if (menu3[0]!=5 && menu3[1]!=5) SetTextColor(hdc,RGB(200,0,0));
		if (menu3[0]==5 && menu3[1]!=5) SetTextColor(hdc,RGB(200,200,0));
		if (menu3[0]!=5 && menu3[1]==5) SetTextColor(hdc,RGB(0,0,200));
		if (menu3[0]==5 && menu3[1]==5) SetTextColor(hdc,RGB(200,200,200));
		TextOut(hdc,(640-s.cx)/2,300,buf,lstrlen(buf));
	}
	if (menu==2)
	{
		lstrcpy(buf,ReturnText("MENU6"));
		GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
		if (mousex>(640-s.cx)/2 && mousex<(640+s.cx)/2 &&
			mousey>100 && mousey<140) {
			menu3[0]=1;
			if (Left_B1 && menu3[1]==1)
			{
				if (sound)
		if (sound_blaster)
					DSOUND(ReturnNumberS("button.wav"));
					menu=0;
					return;
			}
			if (Left_B1) {
				menu3[1]=1;
				if (sound)
		if (sound_blaster)
				DSOUND(ReturnNumberS("menu.wav"));
			}
		}
		if (menu3[0]!=1 && menu3[1]!=1) SetTextColor(hdc,RGB(200,0,0));
		if (menu3[0]==1 && menu3[1]!=1) SetTextColor(hdc,RGB(200,200,0));
		if (menu3[0]!=1 && menu3[1]==1) SetTextColor(hdc,RGB(0,0,200));
		if (menu3[0]==1 && menu3[1]==1) SetTextColor(hdc,RGB(200,200,200));
		TextOut(hdc,(640-s.cx)/2,100,buf,lstrlen(buf));
		lstrcpy(buf,ReturnText("MENU1"));
		GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
		if (mousex>(640-s.cx)/2 && mousex<(640+s.cx)/2 &&
			mousey>150 && mousey<190) {
			menu3[0]=2;
			if (Left_B1 && menu3[1]==2)
			{
				if (sound)
		if (sound_blaster)
					DSOUND(ReturnNumberS("button.wav"));
					NewGame();
					return;
			}
			if (Left_B1) {
				menu3[1]=2;
				if (sound)
		if (sound_blaster)
				DSOUND(ReturnNumberS("menu.wav"));
			}
		}
		if (menu3[0]!=2 && menu3[1]!=2) SetTextColor(hdc,RGB(200,0,0));
		if (menu3[0]==2 && menu3[1]!=2) SetTextColor(hdc,RGB(200,200,0));
		if (menu3[0]!=2 && menu3[1]==2) SetTextColor(hdc,RGB(0,0,200));
		if (menu3[0]==2 && menu3[1]==2) SetTextColor(hdc,RGB(200,200,200));
		TextOut(hdc,(640-s.cx)/2,150,buf,lstrlen(buf));
		lstrcpy(buf,ReturnText("MENU2"));
		GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
		if (mousex>(640-s.cx)/2 && mousex<(640+s.cx)/2 &&
			mousey>200 && mousey<240) {
			menu3[0]=3;
			if (Left_B1 && menu3[1]==3)
			{
				if (sound)
				if (sound_blaster)
					DSOUND(ReturnNumberS("button.wav"));
				menu1=menu;
				menu=6;
				menu3[1]=1;Left_B1=false;
					return;
			}
			if (Left_B1) {
				menu3[1]=3;
				if (sound)
		if (sound_blaster)
				DSOUND(ReturnNumberS("menu.wav"));
			}
		}
		if (menu3[0]!=3 && menu3[1]!=3) SetTextColor(hdc,RGB(200,0,0));
		if (menu3[0]==3 && menu3[1]!=3) SetTextColor(hdc,RGB(200,200,0));
		if (menu3[0]!=3 && menu3[1]==3) SetTextColor(hdc,RGB(0,0,200));
		if (menu3[0]==3 && menu3[1]==3) SetTextColor(hdc,RGB(200,200,200));
		TextOut(hdc,(640-s.cx)/2,200,buf,lstrlen(buf));
		lstrcpy(buf,ReturnText("MENU3"));
		GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
		if (mousex>(640-s.cx)/2 && mousex<(640+s.cx)/2 &&
			mousey>250 && mousey<290) {
			menu3[0]=4;
			if (Left_B1 && menu3[1]==4)
			{
				if (sound)
				if (sound_blaster)
					DSOUND(ReturnNumberS("button.wav"));
				menu1=menu;
				menu=4;
				menu3[1]=1;Left_B1=false;
					return;
			}
			if (Left_B1) {
				menu3[1]=4;
				if (sound)
		if (sound_blaster)
				DSOUND(ReturnNumberS("menu.wav"));
			}
		}
		if (menu3[0]!=4 && menu3[1]!=4) SetTextColor(hdc,RGB(200,0,0));
		if (menu3[0]==4 && menu3[1]!=4) SetTextColor(hdc,RGB(200,200,0));
		if (menu3[0]!=4 && menu3[1]==4) SetTextColor(hdc,RGB(0,0,200));
		if (menu3[0]==4 && menu3[1]==4) SetTextColor(hdc,RGB(200,200,200));
		TextOut(hdc,(640-s.cx)/2,250,buf,lstrlen(buf));
		lstrcpy(buf,ReturnText("MENU4"));
		GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
		if (mousex>(640-s.cx)/2 && mousex<(640+s.cx)/2 &&
			mousey>300 && mousey<340) {
			menu3[0]=5;
			if (Left_B1 && menu3[1]==5)
			{
				if (sound)
				if (sound_blaster)
					DSOUND(ReturnNumberS("button.wav"));
				menu1=menu;
				menu=3;
				menu3[1]=1;Left_B1=false;
					return;
			}
			if (Left_B1){
				menu3[1]=5;
				if (sound)
		if (sound_blaster)
				DSOUND(ReturnNumberS("menu.wav"));
			}
		}
		if (menu3[0]!=5 && menu3[1]!=5) SetTextColor(hdc,RGB(200,0,0));
		if (menu3[0]==5 && menu3[1]!=5) SetTextColor(hdc,RGB(200,200,0));
		if (menu3[0]!=5 && menu3[1]==5) SetTextColor(hdc,RGB(0,0,200));
		if (menu3[0]==5 && menu3[1]==5) SetTextColor(hdc,RGB(200,200,200));
		TextOut(hdc,(640-s.cx)/2,300,buf,lstrlen(buf));
		lstrcpy(buf,ReturnText("MENU5"));
		GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
		if (mousex>(640-s.cx)/2 && mousex<(640+s.cx)/2 &&
			mousey>350 && mousey<390) {
			menu3[0]=6;
			if (Left_B1 && menu3[1]==6)
			{
				if (sound)
				if (sound_blaster)
					DSOUND(ReturnNumberS("button.wav"));
					Exit_Game=true;
					return;
			}
			if (Left_B1) {
				menu3[1]=6;
				if (sound)
		if (sound_blaster)
				DSOUND(ReturnNumberS("menu.wav"));
			}
		}
		if (menu3[0]!=6 && menu3[1]!=6) SetTextColor(hdc,RGB(200,0,0));
		if (menu3[0]==6 && menu3[1]!=6) SetTextColor(hdc,RGB(200,200,0));
		if (menu3[0]!=6 && menu3[1]==6) SetTextColor(hdc,RGB(0,0,200));
		if (menu3[0]==6 && menu3[1]==6) SetTextColor(hdc,RGB(200,200,200));
		TextOut(hdc,(640-s.cx)/2,340,buf,lstrlen(buf));
	}
	if (menu==3)
	{
		SetTextColor(hdc,RGB(200,200,200));
		//  
		for(i=0;i<25;i++) {
			if (i%3==0){
				if (i%2==0) buf[i]=(name4[i]-k3_1*i-k2_1)/(k1_1);
				if (i%2==1) buf[i]=(name4[i]-k3_1*i-k2_2)/k1_1;
			}
			if (i%3==1){
				if (i%2==0) buf[i]=(name4[i]-k3_1*i-k2_1)/k1_2;
				if (i%2==1) buf[i]=(name4[i]-k3_1*i-k2_2)/k1_2;
			}
			if (i%3==2){
				if (i%2==0) buf[i]=(name4[i]-k3_1*i-k2_1)/k1_3;
				if (i%2==1) buf[i]=(name4[i]-k3_1*i-k2_2)/k1_3;
			}
		}
		GetTextExtentPoint32(hdc,buf,25,&s);
		TextOut(hdc,(640-s.cx)/2,150,buf,25);
		for(i=0;i<36;i++) {
			if (i%3==0){
				if (i%2==0) buf[i]=(name5[i]-k3_1*i-k2_1)/(k1_1);
				if (i%2==1) buf[i]=(name5[i]-k3_1*i-k2_2)/k1_1;
			}
			if (i%3==1){
				if (i%2==0) buf[i]=(name5[i]-k3_1*i-k2_1)/k1_2;
				if (i%2==1) buf[i]=(name5[i]-k3_1*i-k2_2)/k1_2;
			}
			if (i%3==2){
				if (i%2==0) buf[i]=(name5[i]-k3_1*i-k2_1)/k1_3;
				if (i%2==1) buf[i]=(name5[i]-k3_1*i-k2_2)/k1_3;
			}
		}
		GetTextExtentPoint32(hdc,buf,36,&s);
		TextOut(hdc,(640-s.cx)/2,200,buf,36);
		lstrcpy(buf,ReturnText("MENU7"));
		GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
		if (mousex>(640-s.cx)/2 && mousex<(640+s.cx)/2 &&
			mousey>300 && mousey<340) {
			menu3[0]=1;
			if (Left_B1 && menu3[1]==1)
			{
				if (sound)
				if (sound_blaster)
					DSOUND(ReturnNumberS("button.wav"));
				menu=menu1;
				if (menu1==1) menu3[1]=4;
				if (menu1==2) menu3[1]=4;
					return;
			}
			if (Left_B1) {
				menu3[1]=1;
				if (sound)
				if (sound_blaster)
				DSOUND(ReturnNumberS("menu.wav"));
			}
		}
		if (menu3[0]!=1 && menu3[1]!=1) SetTextColor(hdc,RGB(200,0,0));
		if (menu3[0]==1 && menu3[1]!=1) SetTextColor(hdc,RGB(200,200,0));
		if (menu3[0]!=1 && menu3[1]==1) SetTextColor(hdc,RGB(0,0,200));
		if (menu3[0]==1 && menu3[1]==1) SetTextColor(hdc,RGB(200,200,200));
		TextOut(hdc,(640-s.cx)/2,300,buf,lstrlen(buf));
	}
	if (menu==4)
	{
		SetTextColor(hdc,RGB(200,200,200));
		for(i=0;i<10;i++)
		{
			TextOut(hdc,100,90+i*30,Rec_buf[i],20);
			wsprintf(buf,"%d",Rec_ochki[i]);
			GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
			TextOut(hdc,540-s.cx,90+i*30,buf,lstrlen(buf));
		}
		lstrcpy(buf,ReturnText("MENU7"));
		GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
		if (mousex>(640-s.cx)/2 && mousex<(640+s.cx)/2 &&
			mousey>400 && mousey<440) {
			menu3[0]=1;
			if (Left_B1 && menu3[1]==1)
			{
				if (sound)
				if (sound_blaster)
					DSOUND(ReturnNumberS("button.wav"));
				menu=menu1;
				if (menu1==1) menu3[1]=3;
				if (menu1==2) menu3[1]=4;
					return;
			}
			if (Left_B1) {
				menu3[1]=1;
				if (sound)
				if (sound_blaster)
				DSOUND(ReturnNumberS("menu.wav"));
			}
		}
		if (menu3[0]!=1 && menu3[1]!=1) SetTextColor(hdc,RGB(200,0,0));
		if (menu3[0]==1 && menu3[1]!=1) SetTextColor(hdc,RGB(200,200,0));
		if (menu3[0]!=1 && menu3[1]==1) SetTextColor(hdc,RGB(0,0,200));
		if (menu3[0]==1 && menu3[1]==1) SetTextColor(hdc,RGB(200,200,200));
		TextOut(hdc,(640-s.cx)/2,400,buf,lstrlen(buf));
	}
	if (menu==5)
	{
		SetTextColor(hdc,RGB(200,0,0));
		lstrcpy(buf,ReturnText("MENU10"));
		GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
		TextOut(hdc,(640-s.cx)/2,100,buf,lstrlen(buf));
		lstrcpy(buf,ReturnText("MENU8"));
		TextOut(hdc,50,240,buf,lstrlen(buf));
		// 
		SetTextColor(hdc,RGB(200,200,200));
		TextOut(hdc,250,240,buffer,lstrlen(buffer));
		// 
		if (tim % 6>2){
			SetTextColor(hdc,RGB(0,200,0));
			GetTextExtentPoint32(hdc,buffer,lstrlen(buffer),&s);
			TextOut(hdc,250+s.cx,240,"_",1);
		}
		lstrcpy(buf,ReturnText("MENU9"));
		GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
		if (mousex>(640-s.cx)/2 && mousex<(640+s.cx)/2 &&
			mousey>340 && mousey<380) {
			menu3[0]=1;
			if (Left_B1 && menu3[1]==1)
			{
				if (sound)
				if (sound_blaster)
					DSOUND(ReturnNumberS("button.wav"));
				menu=4;menu1=1;LaterKeyCod=0;
				menu3[1]=1;Left_B1=false;WriteRecord();
					return;
			}
			if (Left_B1) {
				menu3[1]=1;
				if (sound)
				if (sound_blaster)
				DSOUND(ReturnNumberS("menu.wav"));
			}
		}
		if (menu3[0]!=1 && menu3[1]!=1) SetTextColor(hdc,RGB(200,0,0));
		if (menu3[0]==1 && menu3[1]!=1) SetTextColor(hdc,RGB(200,200,0));
		if (menu3[0]!=1 && menu3[1]==1) SetTextColor(hdc,RGB(0,0,200));
		if (menu3[0]==1 && menu3[1]==1) SetTextColor(hdc,RGB(200,200,200));
		TextOut(hdc,(640-s.cx)/2,340,buf,lstrlen(buf));
	}
	if (menu==6)
	{
		// 
		if (mousex>500 && mousex<540 &&
			mousey>100 && mousey<140) {
			if (Left_B1) {
				if (sound_blaster)
				{
					if (sound) sound=false;
					else sound=true;
				}
			}
		}
		if (mousex>390 && mousex<539 &&
			mousey>150 && mousey<190) {
			if (Left_B1) {
				if (sound)
				if (sound_blaster)
				DSOUND(ReturnNumberS("menu.wav"));
				volume=(mousex-390)/15-9;
				for (i=0;i<max_text_sound;i++) sd[i]->SetVolume(volume*200);
			}
		}
		lstrcpy(buf,ReturnText("MENU11"));
		GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
		if (mousex>100 && mousex<100+s.cx &&
			mousey>100 && mousey<140) {
			menu3[0]=1;
			if (Left_B1) {
				menu3[1]=1;
				if (sound)
				if (sound_blaster)
				DSOUND(ReturnNumberS("menu.wav"));
			}
		}
		if (menu3[0]!=1 && menu3[1]!=1) SetTextColor(hdc,RGB(200,0,0));
		if (menu3[0]==1 && menu3[1]!=1) SetTextColor(hdc,RGB(200,200,0));
		if (menu3[0]!=1 && menu3[1]==1) SetTextColor(hdc,RGB(0,0,200));
		if (menu3[0]==1 && menu3[1]==1) SetTextColor(hdc,RGB(200,200,200));
		TextOut(hdc,100,100,buf,lstrlen(buf));
		lstrcpy(buf,ReturnText("MENU12"));
		GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
		if (mousex>100 && mousex<100+s.cx &&
			mousey>150 && mousey<190) {
			menu3[0]=2;
			if (Left_B1) {
				menu3[1]=2;
				if (sound)
				if (sound_blaster)
				DSOUND(ReturnNumberS("menu.wav"));
			}
		}
		if (menu3[0]!=2 && menu3[1]!=2) SetTextColor(hdc,RGB(200,0,0));
		if (menu3[0]==2 && menu3[1]!=2) SetTextColor(hdc,RGB(200,200,0));
		if (menu3[0]!=2 && menu3[1]==2) SetTextColor(hdc,RGB(0,0,200));
		if (menu3[0]==2 && menu3[1]==2) SetTextColor(hdc,RGB(200,200,200));
		TextOut(hdc,100,150,buf,lstrlen(buf));
		lstrcpy(buf,ReturnText("MENU13"));
		GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
		if (mousex>100 && mousex<100+s.cx &&
			mousey>200 && mousey<240) {
			menu3[0]=3;
			if (Left_B1) {
				menu3[1]=3;
				if (sound)
				if (sound_blaster)
				DSOUND(ReturnNumberS("menu.wav"));
			}
		}
		if (menu3[0]!=3 && menu3[1]!=3) SetTextColor(hdc,RGB(200,0,0));
		if (menu3[0]==3 && menu3[1]!=3) SetTextColor(hdc,RGB(200,200,0));
		if (menu3[0]!=3 && menu3[1]==3) SetTextColor(hdc,RGB(0,0,200));
		if (menu3[0]==3 && menu3[1]==3) SetTextColor(hdc,RGB(200,200,200));
		TextOut(hdc,100,200,buf,lstrlen(buf));
		lstrcpy(buf,ReturnText("MENU14"));
		GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
		if (mousex>100 && mousex<100+s.cx &&
			mousey>250 && mousey<290) {
			menu3[0]=4;
			if (Left_B1 && menu3[1]==4)
			{
				if (sound)
				if (sound_blaster)
					DSOUND(ReturnNumberS("button.wav"));
				menu=7;
				menu3[1]=11;
					return;
			}
			if (Left_B1) {
				menu3[1]=4;
				if (sound)
				if (sound_blaster)
				DSOUND(ReturnNumberS("menu.wav"));
			}
		}
		if (menu3[0]!=4 && menu3[1]!=4) SetTextColor(hdc,RGB(200,0,0));
		if (menu3[0]==4 && menu3[1]!=4) SetTextColor(hdc,RGB(200,200,0));
		if (menu3[0]!=4 && menu3[1]==4) SetTextColor(hdc,RGB(0,0,200));
		if (menu3[0]==4 && menu3[1]==4) SetTextColor(hdc,RGB(200,200,200));
		TextOut(hdc,100,250,buf,lstrlen(buf));
		lstrcpy(buf,ReturnText("MENU7"));
		GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
		if (mousex>(640-s.cx)/2 && mousex<(640+s.cx)/2 &&
			mousey>300 && mousey<340) {
			menu3[0]=5;
			if (Left_B1 && menu3[1]==5)
			{
				if (sound)
				if (sound_blaster)
					DSOUND(ReturnNumberS("button.wav"));
				menu=menu1;
				if (menu1==1) menu3[1]=2;
				if (menu1==2) menu3[1]=3;
				WriteOpt();
					return;
			}
			if (Left_B1) {
				menu3[1]=5;
				if (sound)
				if (sound_blaster)
				DSOUND(ReturnNumberS("menu.wav"));
			}
		}
		if (menu3[0]!=5 && menu3[1]!=5) SetTextColor(hdc,RGB(200,0,0));
		if (menu3[0]==5 && menu3[1]!=5) SetTextColor(hdc,RGB(200,200,0));
		if (menu3[0]!=5 && menu3[1]==5) SetTextColor(hdc,RGB(0,0,200));
		if (menu3[0]==5 && menu3[1]==5) SetTextColor(hdc,RGB(200,200,200));
		TextOut(hdc,(640-s.cx)/2,300,buf,lstrlen(buf));
		//
		wsprintf(buf,"%d",levelnew);
		GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
		SetTextColor(hdc,RGB(0,128,255));
		TextOut(hdc,(540-s.cx),200,buf,lstrlen(buf));
	}

	if (menu==7)
	{
		SelectObject(hdc,font[25]);
		for(i=1;i<10;i++)
		{
		wsprintf(buf1,"KEY%d",i);
		lstrcpy(buf,ReturnText(buf1));
		GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
		if (menu3[3]!=1)
		if (mousex>100 && mousex<100+s.cx &&
			mousey>70+i*30 && mousey<90+i*30) {
			menu3[0]=i;
			if (Left_B1 && menu3[1]==i)
			{
				if (sound)
				if (sound_blaster)
					DSOUND(ReturnNumberS("button.wav"));
				menu3[3]=1;
				Left_B1=false;
					return;
			}
			if (Left_B1) {
				menu3[1]=i;
				if (sound)
				if (sound_blaster)
				DSOUND(ReturnNumberS("menu.wav"));
			}
		}
		if (menu3[0]!=i && menu3[1]!=i) SetTextColor(hdc,RGB(200,0,0));
		if (menu3[0]==i && menu3[1]!=i) SetTextColor(hdc,RGB(200,200,0));
		if (menu3[0]!=i && menu3[1]==i) SetTextColor(hdc,RGB(0,0,200));
		if (menu3[0]==i && menu3[1]==i) SetTextColor(hdc,RGB(200,200,200));
		TextOut(hdc,100,70+i*30,buf,lstrlen(buf));
		SetTextColor(hdc,RGB(0,128,255));
		if (menu3[1]==i && menu3[3]==1)  lstrcpy(buf,"_");
		else lstrcpy(buf,KlaviKod1(keyA[i-1]));
		GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
		if (menu3[1]==i && menu3[3]==1 ) {
			if (tim%6>2) TextOut(hdc,540-s.cx,70+i*30,buf,lstrlen(buf));
		}
		else TextOut(hdc,540-s.cx,70+i*30,buf,lstrlen(buf));
		}
		wsprintf(buf1,"KEY%d",10);
		lstrcpy(buf,ReturnText(buf1));
		GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
		if (menu3[3]!=1)
		if (mousex>(640-s.cx)/2 && mousex<(640+s.cx)/2 &&
			mousey>370 && mousey<390) {
			menu3[0]=10;
			if (Left_B1 && menu3[1]==10)
			{
				if (sound)
				if (sound_blaster)
					DSOUND(ReturnNumberS("button.wav"));
				DefaultKey();
				Left_B1=false;
					return;
			}
			if (Left_B1) {
				menu3[1]=10;
				if (sound)
				if (sound_blaster)
				DSOUND(ReturnNumberS("menu.wav"));
			}
		}
		if (menu3[0]!=10 && menu3[1]!=10) SetTextColor(hdc,RGB(200,0,0));
		if (menu3[0]==10 && menu3[1]!=10) SetTextColor(hdc,RGB(200,200,0));
		if (menu3[0]!=10 && menu3[1]==10) SetTextColor(hdc,RGB(0,0,200));
		if (menu3[0]==10 && menu3[1]==10) SetTextColor(hdc,RGB(200,200,200));
		TextOut(hdc,(640-s.cx)/2,370,buf,lstrlen(buf));
		SelectObject(hdc,font[40]);
		lstrcpy(buf,ReturnText("MENU7"));
		GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
		if (menu3[3]!=1)
		if (mousex>(640-s.cx)/2 && mousex<(640+s.cx)/2 &&
			mousey>400 && mousey<440) {
			menu3[0]=11;
			if (Left_B1 && menu3[1]==11)
			{
				if (sound)
				if (sound_blaster)
					DSOUND(ReturnNumberS("button.wav"));
				menu=6;menu3[1]=4;
					Left_B1=false;
					return;
			}
			if (Left_B1) {
				menu3[1]=11;
				if (sound)
				if (sound_blaster)
				DSOUND(ReturnNumberS("menu.wav"));
			}
		}
		if (menu3[0]!=11 && menu3[1]!=11) SetTextColor(hdc,RGB(200,0,0));
		if (menu3[0]==11 && menu3[1]!=11) SetTextColor(hdc,RGB(200,200,0));
		if (menu3[0]!=11 && menu3[1]==11) SetTextColor(hdc,RGB(0,0,200));
		if (menu3[0]==11 && menu3[1]==11) SetTextColor(hdc,RGB(200,200,200));
		TextOut(hdc,(640-s.cx)/2,400,buf,lstrlen(buf));
		if (menu3[3]==1)
		{
			SelectObject(hdc,font[30]);
			lstrcpy(buf,ReturnText("KEY"));
			GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
			SetTextColor(hdc,RGB(0,128,255));
			TextOut(hdc,(640-s.cx)/2,450,buf,lstrlen(buf));
		}
	}
	if (Left_B1) Left_B1=false;
	
	backsurf->ReleaseDC(hdc);
	//
	if (menu==6)
	{
		if (sound)
		if (sound_blaster)
		BltSurface(backsurf,pv[ReturnNumber("menu\\gal.bmp")],500,100);
		if (!sound || !sound_blaster) BltSurface(backsurf,pv[ReturnNumber("menu\\sqr.bmp")],500,100);
		BltSurface(backsurf,pv[ReturnNumber("menu\\line.bmp")],390,150,true);
		BltSurface(backsurf,pv[ReturnNumber("menu\\line1.bmp")],395+(10+volume-1)*15,150,true);
	}
	// 
	BltSurface(backsurf,pv[ReturnNumber("menu\\cur.bmp")],mousex,mousey,true);
}

void DrawLoading(int i,int h)
{
	int j,k;
	char buf[256];
	HDC hdc;
	if (i==1)
	{
		//  + 
		for(j=0;j<320;j++)
			BltSurface(primsurf,pv1[ReturnNumber1("int\\int0.bmp")],j*2,440);
		for(j=0;j<320;j++)
			BltSurface(primsurf,pv1[ReturnNumber1("int\\int1.bmp")],j*2,459,true);
		primsurf->GetDC(&hdc);
		SelectObject(hdc,font[15]);
		SetBkMode(hdc,TRANSPARENT);
		SetTextColor(hdc,RGB(160,160,160));
		lstrcpy(buf,ReturnText("LOAD3"));
		TextOut(hdc,20,440,buf,strlen(buf));
		primsurf->ReleaseDC(hdc);
	}
	if (i==2)
	{
		//  
		for(j=0;j<320*h/(max_text_sound-1);j++)
			BltSurface(primsurf,pv1[ReturnNumber1("int\\int2.bmp")],j*2,459,true);
	}
	if (i==3)
	{
		for(j=0;j<320;j++)
			BltSurface(primsurf,pv1[ReturnNumber1("int\\int0.bmp")],j*2,440);
		for(j=0;j<320;j++)
			BltSurface(primsurf,pv1[ReturnNumber1("int\\int1.bmp")],j*2,459,true);
		primsurf->GetDC(&hdc);
		SelectObject(hdc,font[15]);
		SetBkMode(hdc,TRANSPARENT);
		SetTextColor(hdc,RGB(160,160,160));
		lstrcpy(buf,ReturnText("LOAD1"));
		TextOut(hdc,20,440,buf,strlen(buf));
		primsurf->ReleaseDC(hdc);
	}
	if (i==4)
	{
		// 
		for(j=0;j<320*(h+1)/(max_text_pic);j++)
			BltSurface(primsurf,pv1[ReturnNumber1("int\\int2.bmp")],j*2,459,true);
	}
	if (i==5)
	{
		for(j=0;j<320;j++)
			BltSurface(primsurf,pv1[ReturnNumber1("int\\int0.bmp")],j*2,440);
		for(j=0;j<320;j++)
			BltSurface(primsurf,pv1[ReturnNumber1("int\\int1.bmp")],j*2,459,true);
		primsurf->GetDC(&hdc);
		SelectObject(hdc,font[15]);
		SetBkMode(hdc,TRANSPARENT);
		SetTextColor(hdc,RGB(160,160,160));
		lstrcpy(buf,ReturnText("LOAD2"));
		TextOut(hdc,20,440,buf,strlen(buf));
		primsurf->ReleaseDC(hdc);
	}
	if (i==6)
	{
		// 
		for(j=0;j<320*(h+1)/((max_type_rot)*36);j++)
			BltSurface(primsurf,pv1[ReturnNumber1("int\\int2.bmp")],j*2,459,true);
	}
}


void DrawPoav()
{
	if (video_poav==1)
	{
		if ((POAV[win_poav*2]+40>SX) &&
			(POAV[win_poav*2]<SX+SCREEN_X) &&
			(POAV[win_poav*2+1]+40>SY) &&
			(POAV[win_poav*2+1]<SY+SCREEN_Y))
			if (poav_zd % 10>4)
			BltSurface(backsurf,pv[ReturnNumber("EFFECT\\poav1.bmp")],
				POAV[win_poav*2]-SX,POAV[win_poav*2+1]-SY,true);
			else
			BltSurface(backsurf,pv[ReturnNumber("EFFECT\\poav2.bmp")],
				POAV[win_poav*2]-SX,POAV[win_poav*2+1]-SY,true);
	}
}

void DrawOtherTanks()
{
	BltSurface(backsurf,pv[ReturnNumber("EFFECT\\tank.bmp")],0,160,true);
	int q,w,i;
	HDC hdc;
	q=0;w=0;
	for(i=1;i<max_object;i++)
	{
		if (object[i].on_off && object[i].Health>0) q++;
		if (object[i].Health>0) w++;
	}
	char buf[256];
	wsprintf(buf,"%d%\\%d\\%d",q,w,max_object-1);
	backsurf->GetDC(&hdc);
	SelectObject(hdc,font[20]);
	SetBkMode(hdc,TRANSPARENT);
	SetTextColor(hdc,RGB(0,0,128));
	TextOut(hdc,40,171,buf,lstrlen(buf));
	backsurf->ReleaseDC(hdc);
}

void DrawRadarHealth()
{
	int k=0;
	int l,i,u;
	BltSurface(backsurf,pv[ReturnNumber("EFFECT\\health1a.bmp")],
		530,SCREEN_Y-20,true);
	u=0;
	for(i=0;i<max_build;i++)
		if (build[i].type==10) {
			u=1;
			break;//
		}
	if (u==0) {
		// 
		tyr_end=1;
			return;
		}
	l=100*build[i].energy/type_build[build[i].type].energy;
	if (l>80) k=4;
	if (l>60 && l<=80) k=3;
	if (l>40 && l<=60) k=2;
	if (l>20 && l<=40) k=1;
	if (l>0 && l<=20) k=0;
	for(i=0;i<l;i++)
		BltSurface1(backsurf,pv[ReturnNumber("EFFECT\\health2a.bmp")],
			533+i,463,k,0,k+1,10);
}

void DrawConsole()
{
	int i,j;
	SIZE s;
	for(i=0;i<6;i++)
		for(j=0;j<16;j++)
			if (consoleProcess1-(200-i*40)>0)
				BltSurface(backsurf,pv[ReturnNumber("EFFECT\\f.bmp")],
					j*40,consoleProcess1-(240-i*40));
	HDC hdc;
	backsurf->GetDC(&hdc);
	SelectObject(hdc,font1[20]);
	SetBkMode(hdc,TRANSPARENT);
	SetTextColor(hdc,RGB(255,255,255));
	for(i=0;i<11;i++)
		TextOut(hdc,0,consoleProcess1-240+i*20,consoleText[i+4],lstrlen(consoleText[i+4]));
	TextOut(hdc,0,consoleProcess1-20,buffer,lstrlen(buffer));
	SetTextColor(hdc,RGB(150,150,150));
	for(i=0;i<11;i++)
		TextOut(hdc,1,consoleProcess1-240+i*20+1,consoleText[i+4],lstrlen(consoleText[i+4]));
	TextOut(hdc,1,consoleProcess1-20+1,buffer,lstrlen(buffer));
	// 
	if (tim % 6>2){
		SetTextColor(hdc,RGB(200,0,0));
		GetTextExtentPoint32(hdc,buffer,lstrlen(buffer),&s);
		TextOut(hdc,s.cx,consoleProcess1-20,"_",1);
	}
	backsurf->ReleaseDC(hdc);
}

void DrawBeginLevel()
{
	BltSurface(backsurf,pv[ReturnNumber("fon\\f3.bmp")],
					74,100);
	HDC hdc;
	char buf[256],b[256];
	SIZE s;
	backsurf->GetDC(&hdc);
	SelectObject(hdc,font[40]);
	SetBkMode(hdc,TRANSPARENT);
	lstrcpy(buf,ReturnText("NEWLEVEL"));
	wsprintf(b,"    %i",level);
	lstrcat(buf,b);
	GetTextExtentPoint32(hdc,buf,lstrlen(buf),&s);
	SetTextColor(hdc,RGB(0,255,0));
	TextOut(hdc,(SCREEN_X-s.cx)/2-1,400,buf,strlen(buf));
	SetTextColor(hdc,RGB(0,100,0));
	TextOut(hdc,(SCREEN_X-s.cx)/2+1,400,buf,strlen(buf));
	SetTextColor(hdc,RGB(0,180,0));
	TextOut(hdc,(SCREEN_X-s.cx)/2,400,buf,strlen(buf));
	backsurf->ReleaseDC(hdc);
}