#include <windows.h>
#include <ddraw.h>
#include <mmsystem.h>
#include <dsound.h>
#include <dinput.h>
#include <math.h>

#ifdef DX_FUNC
#define DXFUNC __declspec( dllexport )
#else
#define DXFUNC __declspec( dllimport )
#endif

DXFUNC int GetVersionDX();

DXFUNC LPDIRECTDRAWSURFACE CreateSurface_(LPDIRECTDRAW2 ddraw2,DWORD w,DWORD h, DWORD depth);
DXFUNC LPDIRECTDRAWSURFACE CreateSurface1_(LPDIRECTDRAW2 ddraw2,DWORD w,DWORD h, DWORD depth);
DXFUNC LPDIRECTDRAWSURFACE CreateSurface_(LPDIRECTDRAW2 ddraw2,LPCTSTR file,char *pakname, DWORD depth);
DXFUNC LPDIRECTDRAWSURFACE CreateSurface1_(LPDIRECTDRAW2 ddraw2,LPCTSTR file,char *pakname, DWORD depth);

DXFUNC LoadSurface_(LPDIRECTDRAW2 ddraw2,LPDIRECTDRAWSURFACE s,LPCTSTR file,char *pakname, DWORD depth);

DXFUNC BOOL ClearSurface( LPDIRECTDRAWSURFACE surf, DWORD clr, RECT* rect=0);
DXFUNC BOOL ClearSurface( LPDIRECTDRAWSURFACE surf, DWORD r, DWORD g, DWORD b, RECT* rect=0);

DXFUNC BOOL BltSurface( LPDIRECTDRAWSURFACE destsurf, LPDIRECTDRAWSURFACE srcsurf, int x, int y, BOOL srccolorkey=false );
DXFUNC BOOL BltSurface1( LPDIRECTDRAWSURFACE destsurf, LPDIRECTDRAWSURFACE srcsurf, int x, int y, 
				int x1,int y1,int x2,int y2,BOOL srccolorkey=false );

DXFUNC BOOL Mirror(LPDIRECTDRAWSURFACE destsurf,LPDIRECTDRAWSURFACE srcsurf,BOOL srccolorkey);

DXFUNC LPDIRECTDRAWSURFACE CreateSurfaceBMP(HINSTANCE hInst,LPDIRECTDRAW2 ddraw2,LPCTSTR file,DWORD depth);
DXFUNC LPDIRECTDRAWSURFACE CreateSurface1BMP(HINSTANCE hInst,LPDIRECTDRAW2 ddraw2,LPCTSTR file,DWORD depth);
DXFUNC LoadSurface(HINSTANCE hInst,LPDIRECTDRAWSURFACE s,LPCTSTR file);


DXFUNC LPDIRECTSOUNDBUFFER CreateSoundBuf(IDirectSound *DirectSound,unsigned long size,
									  WAVEFORMATEX wfx);
DXFUNC WAVEFORMATEX CreateWfx(WORD wFT,WORD nC,DWORD nS,
					   DWORD nA,WORD nB,WORD nBP);
DXFUNC LPDIRECTSOUNDBUFFER CreateSoundB(IDirectSound *DirectSound,char *filename,char *pak);
DXFUNC LPDIRECTSOUNDBUFFER CreateSoundB(IDirectSound *DirectSound,char *filename);

DXFUNC char* KlaviKod1(int kl);

DXFUNC int Turn(LPDIRECTDRAWSURFACE s1,LPDIRECTDRAWSURFACE s2,int rotat
		 ,int x_s1, int y_s1, BYTE Method);
//Vertex
/*Methods:
3,4 - Good
1,2 - Bad
rotat 0.1 of gradus
*/
DXFUNC int Vertix(LPDIRECTDRAWSURFACE s1,LPDIRECTDRAWSURFACE s2,int rotat
		 ,int x_v, int y_v, BYTE Method);
// 
DXFUNC int Vertix1(LPDIRECTDRAWSURFACE s1,LPDIRECTDRAWSURFACE s2,int rotat
		 ,int x_v, int y_v, BYTE Method,int xSize,int ySize);
DXFUNC int CopyPset(LPDIRECTDRAWSURFACE s1,LPDIRECTDRAWSURFACE s2,WORD BYTES,WORD x1,WORD y1,WORD x22,WORD y22);
DXFUNC int TurnNew(LPDIRECTDRAWSURFACE s1,LPDIRECTDRAWSURFACE s2,int rotat,int x_s1, int y_s1, BYTE Method);