#include "sound.h"


int DirectSoundC(HWND h)
{
	for(int i=0;i<MAX_SOUND;i++) sd[i]=NULL;
	HRESULT r;
	r=DirectSoundCreate(NULL,&DirectSound,0);
	if (r!=DS_OK) return 1;
	r=DirectSound->SetCooperativeLevel(h,DSSCL_PRIORITY);
	if (r!=DS_OK) return 2;
	return LoadSound();
}

int DirectSoundEnd(HWND h)
{
	for(int i=0;i<MAX_SOUND;i++) if (sd[i]) sd[i]->Release();
	if (DirectSound) 
	{
		DirectSound->Release();
	    DirectSound=NULL;
	}
	return 0;
}



int DSOUND(int h)
{
	sd[h]->SetCurrentPosition(0); 
	sd[h]->Stop();
	sd[h]->Play(0,0,0);
	return 0;
}

int DSOUND1(int h)
{
	DWORD d;
	sd[h]->GetStatus(&d);
	if (d==DSBSTATUS_PLAYING) return 1;
	return 0;
}

int UdSound()
{
	for(int i=0;i<MAX_SOUND;i++) if (sd[i]!=NULL) sd[i]->Release();
	return 0;
}



int LoadSound()
{
	char s[256]; 
	for(int i=0;i<max_text_sound;i++)
	{
		strcpy(s,"WAV\\");
		strcat(s,text_sound[i]);
		sd[i]=CreateSoundB(DirectSound,s,"pak\\pak2.pak");
		if (sd[i]==NULL)
		{
				return 1;
		}
		DrawLoading(2,i);
	}
	return 0;
}

